/*******************************************************************************
 * This software is copyright (c) 2017 by
 *
 *   TextGrid Consortium (http://www.textgrid.de)
 *
 * This is free software. You can redistribute it and/or modify it under the
 * terms described in the GNU Lesser General Public License v3 of which you
 * should have received a copy. Otherwise you can download it from
 *
 *   http://www.gnu.org/licenses/lgpl-3.0.txt
 *
 * @copyright TextGrid Consortium (http://www.textgrid.de)
 * @copyright SUB Göttingen (http://www.sub.uni-goettingen.de)
 * @license http://www.gnu.org/licenses/lgpl-3.0.txt GNU Lesser General Public
 * License v3
 * @author Stefan E. Funk (funk@sub.uni-goettingen.de)
 ******************************************************************************/

package info.textgrid.middleware.tgauth.tgauthclient;

import info.textgrid.namespaces.middleware.tgauth.PortTgextra;
import info.textgrid.namespaces.middleware.tgauth.Tgextra;

import java.net.URL;
import java.util.Map;

import javax.xml.ws.BindingProvider;

/*******************************************************************************
 * TODOLOG
 *
 *******************************************************************************
 * CHANGELOG
 *
 * 2016-08-03    Funk    Copied from TGCrudClientUtilities.
 ******************************************************************************/

/*******************************************************************************
 * <p>
 * TG-auth client utility class to get appropriate TG-auth clients.
 * </p>
 * 
 * @author Stefan E. Funk, SUB Göttingen
 * @version 2017-07-21
 * @since 2016-08-03
 ******************************************************************************/

public final class TGAuthClientUtilities {

	/**
	 * PRIVATE CONSRUCTOR FOR STATIC CLASS
	 */
	private TGAuthClientUtilities() {
		//
	}

	// **
	// MAIN CLASS
	// **

	/**
	 * <p>
	 * Creates a regular TG-extra stub.
	 * </p>
	 * 
	 * @param theEndpoint
	 * @return A Tgextra service port.
	 */
	public static PortTgextra getTgextra(URL theEndpoint) {

		// Create TG-extra service stubs.
		Tgextra tgextra = new Tgextra((URL) null);
		PortTgextra portTgextra = tgextra.getPort(PortTgextra.class);
		BindingProvider bindingProvider = (BindingProvider) portTgextra;
		Map<String, Object> requestContext = bindingProvider
				.getRequestContext();
		requestContext.put(BindingProvider.ENDPOINT_ADDRESS_PROPERTY,
				theEndpoint.toString());

		return portTgextra;
	}

}
